Delay = 10 ' Delay 10ms between commands

On Error Resume Next

Set LedControl = CreateObject("LEDWiz_Control.LED_Wiz")

If LedControl Is Nothing Then 
 MsgBox "Error: Unable to initialize LEDWiz or Pac-Drive. Verify that the OCX or DLL is registered and the board is connected.",16
End If 

LedControl.Command = "SBA:0,0,0,0,3" ' Reset all LEDWiz banks to off, set pulse speed to 3
WScript.Sleep(Delay)

' Turn on Launch Ball button, full brightness

LedControl.Command = "S02:1" ' Turn on LEDWiz output 2 (Launch Ball button)
WScript.Sleep(Delay)
LedControl.Command = "P02:48" ' Set LEDWiz output 2 to full brightness
WScript.Sleep(Delay)

' Set flipper buttons to white, full brightness

LedControl.Command = "S13:1" ' Turn on LEDWiz output 13 (Flipper buttons, Red)
WScript.Sleep(Delay)
LedControl.Command = "S14:1" ' Turn on LEDWiz output 14 (Flipper buttons, Green)
WScript.Sleep(Delay)
LedControl.Command = "S15:1" ' Turn on LEDWiz output 15 (Flipper buttons, Blue)
WScript.Sleep(Delay)
LedControl.Command = "P13:48" ' Set LEDWiz output 13 to full brightness
WScript.Sleep(Delay)
LedControl.Command = "P14:48" ' Set LEDWiz output 14 to full brightness
WScript.Sleep(Delay)
LedControl.Command = "P15:48" ' Set LEDWiz output 15 to full brightness
WScript.Sleep(Delay)

' Turn on Start button, set to flash

LedControl.Command = "S01:1" ' Turn on LEDWiz output 1 (Start button)
WScript.Sleep(Delay)
LedControl.Command = "P01:130" ' Set LEDWiz output 1 to flash
WScript.Sleep(Delay)

